<?php
function bot($method, $datas = []) {
    static $ch = null;
	global $API_KEY;
    if (is_null($ch)) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 2);
    }
    $url = "https://api.telegram.org/bot" . $API_KEY . "/" . $method;
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
    $res = curl_exec($ch);
    if (curl_error($ch)) {
        throw new Exception(curl_error($ch));
    }
    return json_decode($res);
}
function DBconnect(){
	global $DBNAME;
	global $DBUSERNAME;
	global $DBPASS;
	$connect = mysqli_connect('localhost',$DBUSERNAME,$DBPASS,$DBNAME);
	mysqli_query($connect,"SET NAMES utf8mb4");
	return $connect;
}
function SendMessage($chat_id,$text,$keyboard = null, $id = null){
	bot('sendMessage',[
	'chat_id' => $chat_id,
	'text' => $text,
	'reply_markup' => $keyboard,
	'reply_to_message_id' => $id,
	'parse_mode' => 'html',
	'disable_web_page_preview' => 'true'
	]);
}
function SendFile($chat_id,$type,$file_id,$caption = null,$key = null,$id = null){
	bot("send$type",[
	'chat_id' => $chat_id,
	"$type" => $file_id,
	'caption' => $caption,
	'reply_markup' => $key,
	'parse_mode' => 'html',
	'reply_to_message_id' => $id,
	]);
}
function getcahtMembersCount($chat_id){
	return bot('getChatMembersCount',[
		'chat_id' => $chat_id,
	]);
}
function AnswerCallbackquery($chat_id,$text = null,$alert = false){
	bot('answercallbackquery',[
	'callback_query_id' => $chat_id,
	'text' => $text,
	'show_alert' => $alert,
	

	]);
}
function answerInlineQuery($inline_query_id,$results){
	bot('answerInlineQuery',[
		'inline_query_id' => $inline_query_id,
		'results' => $results,
	]);
}
function editMessageText($chat_id,$text,$keyboard,$message_id,$parse_mode = "html"){
	bot('editmessagetext',[
	'chat_id' => $chat_id,
	'text' => $text,
	'reply_markup' => $keyboard,
	'message_id' => $message_id,
	'parse_mode' => $parse_mode
	]);
}
function editmessagereplymarkup($chatid, $messageid, $key){
	bot('editmessagereplymarkup',[
		'chat_id' => $chatid,
		'message_id' => $messageid,
		'reply_markup' => $key,
	]);
}
function getChatMember($user_id,$chat_id){
	return bot('getChatMember',[
	'chat_id' => $chat_id,
	'user_id' => $user_id
	])->result->status;
}
function DeleteMessage($chat_id,$message_id){
	bot('deletemessage',[
	'chat_id' => $chat_id,
	'message_id' => $message_id
	]);
}
function ForwardMessage($chat_id,$from_chat_id,$message_id){
    return bot('forwardmessage',[
        'chat_id' => $chat_id,
        'from_chat_id' => $from_chat_id,
        'message_id' => $message_id
    ]);
}
function createChatInviteLink($chat_id,$expire_date,$member_limit,$creates_join_request = false){
    return bot('createChatInviteLink',[
        'chat_id' => $chat_id,
        'expire_date' => $expire_date,
        'member_limit' => $member_limit,
		'creates_join_request' => $creates_join_request
    ]);
}
function kickChatMember($chat_id,$user_id){
    return bot('kickChatMember',[
        'chat_id' => $chat_id,
        'user_id' => $user_id,
    ]);
}
function convertFarsiToEnglish($englishNumber = null){
	$newNumbers = range(0, 9);
	$arabic = array('٠', '١', '٢', '٣', '٤', '٥', '٦', '٧', '٨', '٩');
	$persian = array('۰', '۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹');
	$englishNumber =  str_replace($arabic, $newNumbers, $englishNumber);
	$englishNumber =  str_replace($persian, $newNumbers, $englishNumber);
	return $englishNumber ;
}
function online_time_fa($online_time){
	$ttt = time() - $online_time ;
	if ($ttt < 20 * 60 ) {
		return "آنلاین" ;
	}elseif ($ttt >= 20 * 60 && $ttt < 60 * 60) {
		return "کمی قبل آنلاین بود" ;
	}elseif ($ttt >= 60 * 60) {
		return "آفلاین" ;
	}
}
function randerst(){
	$char = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789';
	$randst = null;
	for($i=0;$i<9;$i++){
	$randst .= $char[rand(0,strlen($char))];
	}
	return $randst;
}
?>