<?php


class Database
{

    private $connection;

    // Connect to the Database
    public function __construct($host, $database, $username, $password)
    {
        try {
            $this->connection = mysqli_connect($host, $username, $password, $database);
            if (!$this->connection) {
                throw new \Exception('The connection to the database was not successful: ' . mysqli_connect_error());
                die;
            }
            mysqli_query($this->connection, "SET NAMES utf8mb4");
        } catch (\Throwable $th) {
            echo "Error: " . $th->getMessage();
            die;
        }
    }

    // Disconnected from the database 
    public function __destruct()
    {
        if ($this->connection) {
            mysqli_close($this->connection);
        }
    }

    // Insert to database
    public function insert($table, $data)
    {
        $keys = implode(',', array_keys($data));
        $values = implode(',', array_map(function ($value) {
            return "'" . mysqli_real_escape_string($this->connection, $value) . "'";
        }, array_values($data)));

        $query = "INSERT INTO $table ($keys) VALUES ($values)";

        if (mysqli_query($this->connection, $query)) {
            return [
                'status' => true,
                'insert_id' => mysqli_insert_id($this->connection)
            ];
        } else {
            return [
                'status' => false,
            ];
            // throw new \Exception('Inserting rows to the database was not successful: ' . mysqli_error($this->connection) . "\n query : $query");
        }
    }

    // Update data
    public function update($table, $data, $condition)
    {
        $set = [];
        foreach ($data as $key => $value) {
            $escapedValue = mysqli_real_escape_string($this->connection, $value);
            $set[] = "$key='$escapedValue'";
        }
        $setString = implode(", ", $set);
        $query = "UPDATE $table SET $setString WHERE $condition";

        $result = mysqli_query($this->connection, $query);

        // if (!$result) {
        //     throw new \Exception('Updating the database row was not successful: ' . mysqli_error($this->connection) . "\n query : $query" );
        // }
        // if (mysqli_affected_rows($this->connection) === 0) {
        //     throw new \Exception('No rows updated: ' . "\n query : $query");
        // }
    }

    // Delete data
    public function delete($table, $condition) {
        $query = "DELETE FROM $table WHERE $condition";
        $result = mysqli_query($this->connection, $query);
        // if (!$result) {
        //     throw new \Exception('Deleting the row from the database was not successful: ' . mysqli_error($this->connection) . "\n query : $query" );
        // }

        // if (mysqli_affected_rows($this->connection) === 0) {
        //     throw new \Exception('No rows delete: ' . "\n query : $query");
        // }
    }

    // Select data
    public function select($table, $condition = null, $columns = "*",$limit  = null,$orderby  = null)
    {
        $query = "SELECT $columns FROM $table";
        if ($condition) {
            $query .= " WHERE $condition";
        }
        if ($orderby) {
            $query .= " ORDER BY $orderby";
        }
        if ($limit) {
            $query .= " LIMIT $limit";
        }
        $result = mysqli_query($this->connection, $query);
        if (!$result || mysqli_num_rows($result) === 0) {
            return null;
            #throw new \Exception('No rows found: ' . "\n query : $query");
        }elseif (mysqli_num_rows($result) === 1) return mysqli_fetch_assoc($result);
        else return mysqli_fetch_all($result, MYSQLI_ASSOC);

    }

    public function query($query)
    {
        $result = mysqli_query($this->connection, $query);
        if (!$result) echo "Error: " . mysqli_error($this->connection);
    }

    public function queryselect($query)
    {
        $result = mysqli_query($this->connection, $query);
        if (!$result || mysqli_num_rows($result) === 0) {
            return null;
        }elseif (mysqli_num_rows($result) === 1) return mysqli_fetch_assoc($result);
        else return mysqli_fetch_all($result, MYSQLI_ASSOC);

    }

}
