<?php
# Source by t.me/amirho3ein_hn , t.me/Team_hn 
# 2024/09/16 , 1403/06/26 to 2024/09/19 , 1403/06/29
//======================= [ files ]===========================
include_once('config.php');
include_once('class/Database.php');
include_once('class/Logger.php');
include_once('class/Telegram.php');
require_once('lib/jdf.php');
//======================= [ variables ]===========================
$DB = new Database('localhost',$DBNAME,$DBUSERNAME,$DBPASS);
$telegram = new Telegram($API_KEY,false);
$text = $telegram->Text();
$chat_id = $telegram->ChatID();
$from_id = $telegram->UserID();
$data = $telegram->Callback_Data() ;
$message_id = $telegram->messageID();
$getuser = $DB->select('users',"from_id=$from_id");
$command = isset($getuser['command']) ? $getuser['command'] : null ;
//======================= [ start ]===========================
if (isset($text) && $text == '/start') {
    //===========[ User registration ]===========
    if(!isset($getuser)){
        $DB->insert('users',['from_id' => $from_id]);
    }else{
        $DB->update('users',['command' => 'none'],"from_id=$from_id");
        $command = 'none';
    }

    if(!in_array($from_id,$ADMINS)){
        if (!isset($getuser) || isset($getuser) && $getuser['is_admin'] == 0) {
            $telegram->sendMessage(['chat_id' => $from_id,'text' => 'شما دسترسی استفاده از ربات را ندارید','parse_mode' => 'html']);
            exit;
        }
    }

    $telegram->sendMessage(['chat_id' => $from_id,'text' => 'به ربات ثبت بنر خوش آمدید','parse_mode' => 'html','reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
        [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
        [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
        [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
        [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],
        [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]],   
    ]])]);
    exit;
}
//======================= [ Access check ]===========================
if(!in_array($from_id,$ADMINS)){
    if (!isset($getuser) || isset($getuser) && $getuser['is_admin'] == 0) {
        $telegram->sendMessage(['chat_id' => $from_id,'text' => 'شما دسترسی استفاده از ربات را ندارید','parse_mode' => 'html']);
        exit;
    }
}
//======================= [ برگشت به خانه ]===========================
if(isset($data) && $data == 'back_home'){
    $DB->update('users',['command' => 'none'],"from_id=$from_id");
    $command = 'none';
    $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
	$telegram->sendMessage(['chat_id' => $from_id,'text' => 'به منوی اصلی برگشتید','reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
        [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
        [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
        [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
        [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],  
        [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]], 
    ]])]);
	exit;
}
//======================= [ دکمه نمایشی ]===========================
if(isset($data) && $data == 'show'){
    $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "این دکمه نمایشی است"]);
    exit;
}
//======================= [ اضافه کردن بنر ]===========================
elseif(isset($data) && $data == 'add_banner'){
	$telegram->editMessageText(['chat_id' => $from_id,'text' => "لطفا بنر خود را ارسال کنید. میتواند فایل یا عکس یا ویدیو یا ویس یا ... باشد",'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'برگشت' ,'callback_data' => "back_home"]],  
    ]])]);
    $DB->update('users',['command' => 'add_banner'],"from_id=$from_id");
	exit;
}
elseif($telegram->ismessage() && $command == 'add_banner'){
    $time = time();
    if ($telegram->isforward()) $insert = $DB->insert('banner',['from_id' => $from_id, 'add_time' => $time,'type_file' => 'forward',  'file_id' => $message_id, 'add_time' => $time]);
    elseif ($telegram->getUpdateType() == 'message') $insert = $DB->insert('banner',['from_id' => $from_id, 'add_time' => $time,'type_file' => $telegram->getUpdateType() ,  'description' => $text, 'add_time' => $time]);
    elseif ($telegram->getUpdateType() == 'photo') $insert = $DB->insert('banner',['from_id' => $from_id, 'add_time' => $time,'type_file' => $telegram->getUpdateType() , 'file_id' => $telegram->fileID(), 'description' => $telegram->Caption(), 'add_time' => $time]);
    elseif ($telegram->getUpdateType() == 'video') $insert = $DB->insert('banner',['from_id' => $from_id, 'add_time' => $time,'type_file' => $telegram->getUpdateType() , 'file_id' => $telegram->fileID(), 'description' => $telegram->Caption(), 'add_time' => $time]);
    elseif ($telegram->getUpdateType() == 'voice') $insert = $DB->insert('banner',['from_id' => $from_id, 'add_time' => $time,'type_file' => $telegram->getUpdateType() , 'file_id' => $telegram->fileID(), 'description' => $telegram->Caption(), 'add_time' => $time]);
    elseif ($telegram->getUpdateType() == 'document') $insert = $DB->insert('banner',['from_id' => $from_id, 'add_time' => $time,'type_file' => $telegram->getUpdateType() , 'file_id' => $telegram->fileID(), 'description' => $telegram->Caption(), 'add_time' => $time]);
    elseif ($telegram->getUpdateType() == 'audio') $insert = $DB->insert('banner',['from_id' => $from_id, 'add_time' => $time,'type_file' => $telegram->getUpdateType() , 'file_id' => $telegram->fileID(), 'description' => $telegram->Caption(), 'add_time' => $time]);
    else{
        $telegram->sendMessage(['chat_id' => $from_id,'text' => "❗️ فرمت پیام پشتیبانی نمی شود",'reply_markup' => json_encode(['inline_keyboard'=>[
            [['text' => 'برگشت' ,'callback_data' => "back_home"]],  
        ]])]);
        exit ;
    }
    if ($insert['status'] == true) {
        $telegram->sendMessage(['chat_id' => $from_id,'text' => "بنر با موفقیت اضافه شد\nاز بخش بنر های ثبت شده میتوانید کانال هایی را که باید بنر ارسال شود را مشخص کنید.\nآیدی بنر در دیتابیس : {$insert['insert_id']}",'reply_markup' => json_encode(['inline_keyboard'=>[
            [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
            [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
            [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
            [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
            [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],  
            [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]], 
        ]])]);
        $DB->update('users',['command' => "none"],"from_id=$from_id");
    }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "مشکلی پیش آمد لطفا دوباره امتحان کنید",'parse_mode' => 'html']);
    exit ;
}
//======================= [ بنر های ثبت شده ]===========================
elseif(isset($data) && strpos($data,'registered_banners') !== false){
    $numberpage = explode("-",$data)[1];	
	if ($numberpage == 0 ){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "صفحه قبلی وجود ندارد"]);
		exit;
	}
    $count_show = 10 ;
	$numberpage_next = $numberpage + 1 ;	
	$numberpage_befor = $numberpage - 1 ;	
	$start_number = ($numberpage - 1) * $count_show ;
	$getbanners = $DB->select('banner',null,'id,add_time,type_file,description',"$start_number,$count_show",'add_time DESC');
    if (is_null($getbanners)){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "نتیجه ای یافت نشد"]);
		exit;
	}
    $arr = [];
	$arr[] = [['text' => "اطلاعات",'callback_data' => "show"],['text' => "آیدی - نمونه متن",'callback_data' => "show"]];
    if (is_array($getbanners) && isset($getbanners[1]['id'])) {
        # [{"id":"5","add_time":"1726499301"},{"id":"4","add_time":"1726498514"}]
        foreach ($getbanners as $key) {
            if ($key['type_file'] != 'forward') {
                if (is_null($key['description']) || $key['description'] === '') {
                    $resultString = "بدون کپشن";           
                } else {
                    $resultString = (mb_strlen($key['description']) <= 18) ? $key['description'] : mb_substr($key['description'], 0, 18);
                }
            } else {
                $resultString = "فوروارد";
            }
            $arr[] = [['text' => 'کلیک کن', 'callback_data' => "infobanners-{$key['id']}"], ['text' => $resultString, 'callback_data' => "show"]];
        }        
    } else {
        # {"id":"1","add_time":"1726498450"}
        if ($getbanners['type_file'] != 'forward') {
            if (is_null($getbanners['description'])) {
                $resultString = "بدون کپشن";           
            }else {
                if (strlen($getbanners['description']) <= 10) $resultString = $getbanners['description'];
                else $resultString = substr($getbanners['description'], 0, 10);
            }
        }else $resultString = "فوروارد";
        $arr[] = [['text' => 'کلیک کن', 'callback_data' => "infobanners-{$getbanners['id']}"], ['text' => $resultString, 'callback_data' => "show"]];
    }
    $arr[] = [['text' => "بعدی",'callback_data' => "registered_banners-$numberpage_next"],['text' => "قبلی",'callback_data' => "registered_banners-$numberpage_befor"]];
	$arr[] = [['text' => "برگشت",'callback_data' => "back_home"]];
    $telegram->editMessageText(['chat_id' => $from_id,'text' => "لیست بنر ها :",'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard' => $arr ])]);
	exit;
}
# اطلاعات بنر
elseif(isset($data) && strpos($data,'infobanners') !== false){
    $id_banner = explode('-',$data)[1];
    $getbanner = $DB->select('banner',"id=$id_banner");
    if(isset($getbanner) && !is_null($getbanner)){
        if($getbanner['type_file'] == 'forward') $send = $telegram->forwardMessage(['chat_id' => $from_id,'from_chat_id' => $getbanner['from_id'],'message_id' => $getbanner['file_id'] ]);
        elseif ($getbanner['type_file'] == 'message') $send = $telegram->sendMessage(['chat_id' => $from_id,'text' => $getbanner['description']]);
        else $send = $telegram->sendFile($getbanner['type_file'],['chat_id' => $from_id,$getbanner['type_file'] => $getbanner['file_id'],'caption' => $getbanner['description']]) ;
        $add_time = jdate("Y/m/d H:i", $getbanner['add_time']);
        $telegram->sendMessage(['chat_id' => $from_id,'text' => "
<b>اطلاعات بنر</b>

<b>آیدی دیتابیس :</b> <code>{$getbanner['id']}</code> 
<b>چت آیدی اضافه کننده :</b> <code>{$getbanner['from_id']}</code> 
<b>تاریخ اضافه شدن :</b> $add_time
        ",'parse_mode' => 'html','reply_to_message_id' => $send['result']['message_id'],'reply_markup' => json_encode(['inline_keyboard'=>[
            [['text' => "کانال های ثبت شده" ,'callback_data' => "banner_channels-{$getbanner['id']}-1"]],
            [['text' => "حذف بنر" ,'callback_data' => "del_banner-{$getbanner['id']}"]],
            [['text' => "برگشت",'callback_data' => "back_home"]], 
        ]])]);
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
    }else $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "بنر یافت نشد"]);
    exit;
}
# کانال های ثبت شده برای بنر
elseif(isset($data) && strpos($data,'banner_channels') !== false){
    $ex = explode('-',$data);
    $id_banner = $ex[1];
    $numberpage = $ex[2];
	if ($numberpage == 0 ){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "صفحه قبلی وجود ندارد"]);
		exit;
	}
    $count_show = 10 ;
	$numberpage_next = $numberpage + 1 ;	
	$numberpage_befor = $numberpage - 1 ;	
	$start_number = ($numberpage - 1) * $count_show ;
	$getchannels = $DB->select('channel',null,'id,chatid,invite_link',"$start_number,$count_show",'add_time DESC');
    if (is_null($getchannels)){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "کانالی در دیتابیس ثبت نشد است"]);
		exit;
	}
    $arr = [];
    $arr[] = [['text' => "وضیعت",'callback_data' => "show"],['text' => "کانال",'callback_data' => "show"]];
	if (is_array($getchannels) && isset($getchannels[1]['id'])) {
        foreach ($getchannels as $key) {
            $check = $DB->select('banner_order',"channel_id={$key['id']} AND banner_id=$id_banner",'id');
            $getchat = $telegram->getChat(['chat_id' => $key['chatid']]);
            $title = $getchat['ok'] == true ? $getchat['result']['title'] : "اسم یافت نشد" ;
            if (is_null($check)) $arr[] = [['text' => '❌', 'callback_data' => "editstachban-$id_banner-$numberpage-{$key['id']}-1"],['text' => $title , 'url' => $key['invite_link']]];
            else $arr[] = [['text' => '✅', 'callback_data' => "editstachban-$id_banner-$numberpage-{$key['id']}-0"],['text' => $title , 'url' => $key['invite_link']]];
        }
    } else {
        $check = $DB->select('banner_order',"channel_id={$getchannels['id']} AND banner_id=$id_banner",'id');
        $getchat = $telegram->getChat(['chat_id' => $getchannels['chatid']]);
        $title = $getchat['ok'] == true ? $getchat['result']['title'] : "اسم یافت نشد" ;
        if (is_null($check)) $arr[] = [['text' => '❌', 'callback_data' => "editstachban-$id_banner-$numberpage-{$getchannels['id']}-1"],['text' => $title , 'url' => $getchannels['invite_link']]];
        else $arr[] = [['text' => '✅', 'callback_data' => "editstachban-$id_banner-$numberpage-{$getchannels['id']}-0"],['text' => $title , 'url' => $getchannels['invite_link']]];
    }
    $arr[] = [['text' => "بعدی",'callback_data' => "banner_channels-$id_banner-$numberpage_next"],['text' => "قبلی",'callback_data' => "banner_channels-$id_banner-$numberpage_befor"]];
	$arr[] = [['text' => "برگشت",'callback_data' => "back_home"]];
    $telegram->editMessageText(['chat_id' => $from_id,'text' => "اینجا لیستی از کانال ها را میبینید.\nبرای تنظیم هر کانال برای این بنر روی آن کلیک کنید",'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard' => $arr ])]);
}
# ویرایش کانال های ثبت شده برای بنر
elseif(isset($data) && strpos($data,'editstachban') !== false){
    $ex = explode('-',$data);
    $id_banner = $ex[1];
    $numberpage = $ex[2];
    $channel_id = $ex[3];
    $status = $ex[4];
    if ($status == 1) $DB->insert('banner_order',['banner_id' => $id_banner,'channel_id' => $channel_id,'order_time' => time() ]);
    else $DB->delete('banner_order',"banner_id=$id_banner AND channel_id=$channel_id");
    $count_show = 10 ;
	$numberpage_next = $numberpage + 1 ;	
	$numberpage_befor = $numberpage - 1 ;	
	$start_number = ($numberpage - 1) * $count_show ;
	$getchannels = $DB->select('channel',null,'id,chatid,invite_link',"$start_number,$count_show",'add_time DESC');
    $arr = [];
    $arr[] = [['text' => "وضیعت",'callback_data' => "show"],['text' => "کانال",'callback_data' => "show"]];
    if (!is_null($getchannels)){
        if (is_array($getchannels) && isset($getchannels[1]['id'])) {
            foreach ($getchannels as $key) {
                $check = $DB->select('banner_order',"channel_id={$key['id']} AND banner_id=$id_banner",'id');
                $getchat = $telegram->getChat(['chat_id' => $key['chatid']]);
                $title = $getchat['ok'] == true ? $getchat['result']['title'] : "اسم یافت نشد" ;
                if (is_null($check)) $arr[] = [['text' => '❌', 'callback_data' => "editstachban-$id_banner-$numberpage-{$key['id']}-1"],['text' => $title , 'url' => $key['invite_link']]];
                else $arr[] = [['text' => '✅', 'callback_data' => "editstachban-$id_banner-$numberpage-{$key['id']}-0"],['text' => $title , 'url' => $key['invite_link']]];
            }
        } else {
            $check = $DB->select('banner_order',"channel_id={$getchannels['id']} AND banner_id=$id_banner",'id');
            $getchat = $telegram->getChat(['chat_id' => $getchannels['chatid']]);
            $title = $getchat['ok'] == true ? $getchat['result']['title'] : "اسم یافت نشد" ;
            if (is_null($check)) $arr[] = [['text' => '❌', 'callback_data' => "editstachban-$id_banner-$numberpage-{$getchannels['id']}-1"],['text' => $title , 'url' => $getchannels['invite_link']]];
            else $arr[] = [['text' => '✅', 'callback_data' => "editstachban-$id_banner-$numberpage-{$getchannels['id']}-0"],['text' => $title , 'url' => $getchannels['invite_link']]];
        }
	}
    $arr[] = [['text' => "بعدی",'callback_data' => "banner_channels-$id_banner-$numberpage_next"],['text' => "قبلی",'callback_data' => "banner_channels-$id_banner-$numberpage_befor"]];
	$arr[] = [['text' => "برگشت",'callback_data' => "back_home"]];
    $telegram->editMessageReplyMarkup(['chat_id' => $from_id,'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard' => $arr ])]);
}
# حذف بنر
elseif(isset($data) && strpos($data,'del_banner') !== false){
    $id_banner = explode('-',$data)[1];
    $telegram->sendMessage(['chat_id' => $from_id,'text' => "<b>آیا مطمعن هستید که میخواهید بنر را حذف کنید؟</b>",'parse_mode' => 'html','reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => "نه منصرف شدم" ,'callback_data' => "back_home"]],
        [['text' => "آره حذفش کن" ,'callback_data' => "del_2banner-$id_banner"]],
        [['text' => "نه منصرف شدم" ,'callback_data' => "back_home"]],
        [['text' => "برگشت",'callback_data' => "back_home"]], 
    ]])]);
    $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
    exit;
}
elseif(isset($data) && strpos($data,'del_2banner') !== false){
    $id_banner = explode('-',$data)[1];
    $DB->delete('banner',"id=$id_banner");
    $DB->delete('banner_order',"banner_id=$id_banner");
    $telegram->sendMessage(['chat_id' => $from_id,'text' => "بنر مد نظر حذف شد",'parse_mode' => 'html','reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
        [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
        [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
        [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
        [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],
        [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]],   
    ]])]);
    $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
	exit;
}
//======================= [ اضافه کردن کانال ]===========================
elseif(isset($data) && $data == 'add_channel'){
	$telegram->editMessageText(['chat_id' => $from_id,'text' => "لطفا در سطر اول بازه های ارسال آگهی در این کنال را ارسال کنید،در سطر دوم تعداد ذخیره بنر در این کانال را ارسال کنید\n\nمثال : \n3\n5\n\nیعنی هر 3 دقیقه یک بنر ارسال میشود و بعد از ارسال 5 بنر ،بنر اول حذف میشود",'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'برگشت' ,'callback_data' => "back_home"]],  
    ]])]);
    $DB->update('users',['command' => 'add_channel_1'],"from_id=$from_id");
	exit;
}
elseif(isset($text) && $command == 'add_channel_1'){
	$ex = explode("\n",$text);
    if (!array_key_exists(0,$ex) || !array_key_exists(1,$ex)) {
        $telegram->sendMessage(['chat_id' => $from_id,'text' => "لطفا به فرمت صحیح ارسال کنید",'parse_mode' => 'html']);
        exit;
    }
    $gap_send_next_banner = $ex[0];
    $max_save_banner = $ex[1];
    if (!is_numeric($gap_send_next_banner) || is_numeric($gap_send_next_banner) && $gap_send_next_banner < 1) {
        $telegram->sendMessage(['chat_id' => $from_id,'text' => "لطفا عددی بزرگتر از یک ارسال کنید",'parse_mode' => 'html']);
        exit;
    }
    if (!is_numeric($max_save_banner) || is_numeric($max_save_banner) && $max_save_banner < 1) {
        $telegram->sendMessage(['chat_id' => $from_id,'text' => "لطفا عددی بزرگتر از یک ارسال کنید",'parse_mode' => 'html']);
        exit;
    }
    $DB->update('users',['command' => "add_channel_2-$gap_send_next_banner-$max_save_banner"],"from_id=$from_id");
    $telegram->sendMessage(['chat_id' => $from_id,'text' => "لطفا چت آیدی کانالی که میخواهید ثبت کنید را ارسال کنید",'reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'برگشت' ,'callback_data' => "back_home"]],  
    ]])]);
    exit;
}
elseif(isset($text) && strpos($command,'add_channel_2') !== false){
    $botid = explode(":",$API_KEY)[0];
    $check = $telegram->getChatMember(['chat_id' => $text,'user_id' => $botid]);
    if($check['ok'] == true && $check['result']['status'] == 'administrator'){
        $ex = explode("-",$command);
        $gap_send_next_banner = $ex[1];
        $max_save_banner = $ex[2];
        $getchat = $telegram->getChat(['chat_id' => $text]);
        if($getchat['ok'] == true){
            $title = $getchat['result']['title'];
            $createinvitelink = $telegram->createChatInviteLink(['chat_id' => $text]);
            if ($createinvitelink['ok'] == true && isset($createinvitelink['result']['invite_link'])) {
                $invite_link = $createinvitelink['result']['invite_link'];
				$time = time();
                $insert = $DB->insert('channel',['chatid' => $text, 'invite_link' => $invite_link,'gap_send_next_banner' => $gap_send_next_banner,  'max_save_banner' => $max_save_banner, 'add_time' => $time]);
                if ($insert['status'] == true) {
                    $telegram->sendMessage(['chat_id' => $from_id,'text' => "کانال جدید با نام « $title » اضافه شد.\nآیدی دیتابیس : {$insert['insert_id']}",'reply_markup' => json_encode(['inline_keyboard'=>[
                        [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
                        [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
                        [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
                        [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
                        [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],  
                        [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]], 
                    ]])]);
                    $DB->update('users',['command' => "none"],"from_id=$from_id");
                }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "مشکلی پیش آمد لطفا دوباره امتحان کنید",'parse_mode' => 'html']);
            }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "مشکلی پیش آمد لطفا دوباره امتحان کنید",'parse_mode' => 'html']);
        }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "مشکلی پیش آمد لطفا دوباره امتحان کنید",'parse_mode' => 'html']);
    }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "لطفا ربات را در کانال ادمین کرده و سپس چت آیدی آن را ارسال کنید",'parse_mode' => 'html']);
    exit;
}
//======================= [ کانال های ثبت شده ]===========================
elseif(isset($data) && strpos($data,'registered_channels') !== false){
	$numberpage = explode("-",$data)[1];	
	if ($numberpage == 0 ){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "صفحه قبلی وجود ندارد"]);
		exit;
	}
    $count_show = 10 ;
	$numberpage_next = $numberpage + 1 ;	
	$numberpage_befor = $numberpage - 1 ;	
	$start_number = ($numberpage - 1) * $count_show ;
	$getchannels = $DB->select('channel',null,'id,chatid,invite_link',"$start_number,$count_show",'add_time DESC');
    if (is_null($getchannels)){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "نتیجه ای یافت نشد"]);
		exit;
	}
    $arr = [];
	$arr[] = [['text' => "اطلاعات",'callback_data' => "show"],['text' => "کانال",'callback_data' => "show"]];
    if (is_array($getchannels) && isset($getchannels[1]['id'])) {
        foreach ($getchannels as $key) {
            $getchat = $telegram->getChat(['chat_id' => $key['chatid']]);
            $title = $getchat['ok'] == true ? $getchat['result']['title'] : "اسم یافت نشد" ;
            $arr[] = [['text' => 'کلیک کن', 'callback_data' => "infochannels-{$key['id']}"], ['text' => $title, 'url' => $key['invite_link'] ]];
        }
    } else {
        $getchat = $telegram->getChat(['chat_id' => $getchannels['chatid']]);
        $title = $getchat['ok'] == true ? $getchat['result']['title'] : "اسم یافت نشد" ;
        $arr[] = [['text' => 'کلیک کن', 'callback_data' => "infochannels-{$getchannels['id']}"], ['text' => $title , 'url' => $getchannels['invite_link'] ]];
    }
    $arr[] = [['text' => "بعدی",'callback_data' => "registered_channels-$numberpage_next"],['text' => "قبلی",'callback_data' => "registered_channels-$numberpage_befor"]];
	$arr[] = [['text' => "برگشت",'callback_data' => "back_home"]];
    $telegram->editMessageText(['chat_id' => $from_id,'text' => "لیست بنر ها :",'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard' => $arr ])]);
	exit;
}
# اطلاعات کانال 
elseif(isset($data) && strpos($data,'infochannels') !== false){
    $id_channel = explode('-',$data)[1];
    $getchannel = $DB->select('channel',"id=$id_channel");
    if(isset($getchannel) && !is_null($getchannel)){
        $add_time = jdate("Y/m/d H:i", $getchannel['add_time']);
        $telegram->sendMessage(['chat_id' => $from_id,'text' => "
<b>اطلاعات کانال</b>

<b>آیدی دیتابیس :</b> <code>{$getchannel['id']}</code> 
<b>چت آیدی کانال:</b> <code>{$getchannel['chatid']}</code> 
<b>محدودیت ذخیره بنر در کانال :</b> {$getchannel['max_save_banner']} عدد 
<b>باه های زمانی ارسال بنر :</b> {$getchannel['gap_send_next_banner']} دقیقه 

<b>تاریخ اضافه شدن :</b> $add_time
<b>لینک عضویت :</b> 
{$getchannel['invite_link']}
        ",'parse_mode' => 'html','reply_markup' => json_encode(['inline_keyboard'=>[
            [['text' => "بنر های ثبت شده" ,'callback_data' => "channel_banners-{$getchannel['id']}-1"]],
            [['text' => "حذف کانال" ,'callback_data' => "del_channel-{$getchannel['id']}"]],
            [['text' => "ویرایش محدودیت ذخیره : {$getchannel['max_save_banner']}" ,'callback_data' => "show"]],
            [['text' => "-5",'callback_data' => "editch45-$id_channel-max_save_banner-1"],['text' => "-1",'callback_data' => "editch45-$id_channel-max_save_banner-2"],['text' => "+1",'callback_data' => "editch45-$id_channel-max_save_banner-3"],['text' => "+5",'callback_data' => "editch45-$id_channel-max_save_banner-4"]],
            [['text' => "ویرایش بازه های ارسال : {$getchannel['gap_send_next_banner']}" ,'callback_data' => "show"]],
            [['text' => "-5",'callback_data' => "editch45-$id_channel-gap_send_next_banner-1"],['text' => "-1",'callback_data' => "editch45-$id_channel-gap_send_next_banner-2"],['text' => "+1",'callback_data' => "editch45-$id_channel-gap_send_next_banner-3"],['text' => "+5",'callback_data' => "editch45-$id_channel-gap_send_next_banner-4"]],
            [['text' => "برگشت",'callback_data' => "back_home"]], 
        ]])]);
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
    }else $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "کانال یافت نشد"]);
    exit;
}
# بنر های ثبت شده برای کانال
elseif(isset($data) && strpos($data,'channel_banners') !== false){
    $ex = explode("-",$data);	
    $id_channel = $ex[1];
    $numberpage = $ex[2];	
	if ($numberpage == 0 ){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "صفحه قبلی وجود ندارد"]);
		exit;
	}
    $count_show = 10 ;
	$numberpage_next = $numberpage + 1 ;	
	$numberpage_befor = $numberpage - 1 ;	
	$start_number = ($numberpage - 1) * $count_show ;
	$getorders = $DB->select('banner_order',"channel_id=$id_channel",'id,banner_id,order_time',"$start_number,$count_show",'order_time DESC');
    if (is_null($getorders)){
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "نتیجه ای یافت نشد"]);
		exit;
	}
    $arr = [];
	$arr[] = [['text' => "اطلاعات",'callback_data' => "show"],['text' => "آیدی بنر - تاریخ ثبت",'callback_data' => "show"]];
    if (is_array($getorders) && isset($getorders[1]['id'])) {
        foreach ($getorders as $key) {
            $getbanner = $DB->select('banner',"id={$key['banner_id']}",'id');
            $arr[] = [['text' => 'کلیک کن', 'callback_data' => "infobanners-{$getbanner['id']}"], ['text' => jdate("Y/m/d H:i", $key['order_time']) . " - {$key['banner_id']}", 'callback_data' => "show"]];
        }
    } else {
        $getbanner = $DB->select('banner',"id={$getorders['banner_id']}",'id');
        $arr[] = [['text' => 'کلیک کن', 'callback_data' => "infobanners-{$getbanner['id']}"], ['text' => jdate("Y/m/d H:i", $getorders['order_time']) . " - {$getorders['banner_id']}", 'callback_data' => "show"]];
    }
    $arr[] = [['text' => "بعدی",'callback_data' => "channel_banners-$id_channel-$numberpage_next"],['text' => "قبلی",'callback_data' => "channel_banners-$id_channel-$numberpage_befor"]];
	$arr[] = [['text' => "برگشت",'callback_data' => "back_home"]];
    $telegram->editMessageText(['chat_id' => $from_id,'text' => "لیست بنر های ثبت شده برای این کانال :",'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard' => $arr ])]);
	exit;
}
# حذف کانال
elseif(isset($data) && strpos($data,'del_channel') !== false){
    $id_channel = explode('-',$data)[1];
    $telegram->sendMessage(['chat_id' => $from_id,'text' => "<b>آیا مطمعن هستید که میخواهید کانال را حذف کنید؟</b>",'parse_mode' => 'html','reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => "نه منصرف شدم" ,'callback_data' => "back_home"]],
        [['text' => "آره حذفش کن" ,'callback_data' => "del_2channel-$id_channel"]],
        [['text' => "نه منصرف شدم" ,'callback_data' => "back_home"]],
        [['text' => "برگشت",'callback_data' => "back_home"]], 
    ]])]);
    $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
    exit;
}
elseif(isset($data) && strpos($data,'del_2channel') !== false){
    $id_channel = explode('-',$data)[1];
    $DB->delete('channel',"id=$id_channel");
    $DB->delete('banner_order',"channel_id=$id_channel");
    $DB->delete('banner_send',"channel_id=$id_channel");
    $telegram->sendMessage(['chat_id' => $from_id,'text' => "کانال مد نظر حذف شد",'parse_mode' => 'html','reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
        [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
        [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
        [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
        [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],
        [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]],   
    ]])]);
    $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
	exit;
}
# ویرایش تنظیمات کانال
elseif(isset($data) && strpos($data,'editch45') !== false){
    $ex = explode('-',$data);
    $id_channel = $ex[1];
    $which = $ex[2];
    $change = str_replace([1,2,3,4],[-5,-1,+1,+5],$ex[3]);
    $getchannel = $DB->select('channel',"id=$id_channel","$which");
    $value = $getchannel[$which] + $change ; 
    if ($which == 'max_save_banner') {
        if ($value > 0 ) $valuee = $value ;
        else $valuee = 0 ;
    }else {
        if ($value > 1 ) $valuee = $value ;
        else $valuee = 1 ;
    }
    $DB->update('channel',[$which => $valuee],"id=$id_channel");

    $getchannel = $DB->select('channel',"id=$id_channel");
    if(isset($getchannel) && !is_null($getchannel)){
        $add_time = jdate("Y/m/d H:i", $getchannel['add_time']);
        $telegram->editMessageText(['chat_id' => $from_id,'text' => "
<b>اطلاعات کانال</b>

<b>آیدی دیتابیس :</b> <code>{$getchannel['id']}</code> 
<b>چت آیدی کانال:</b> <code>{$getchannel['chatid']}</code> 
<b>محدودیت ذخیره بنر در کانال :</b> {$getchannel['max_save_banner']} عدد 
<b>باه های زمانی ارسال بنر :</b> {$getchannel['gap_send_next_banner']} دقیقه 

<b>تاریخ اضافه شدن :</b> $add_time
<b>لینک عضویت :</b> {$getchannel['invite_link']}
        ",'parse_mode' => 'html','message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard'=>[
            [['text' => "بنر های ثبت شده" ,'callback_data' => "channel_banners-{$getchannel['id']}-1"]],
            [['text' => "حذف کانال" ,'callback_data' => "del_channel-{$getchannel['id']}"]],
            [['text' => "ویرایش محدودیت ذخیره : {$getchannel['max_save_banner']}" ,'callback_data' => "show"]],
            [['text' => "-5",'callback_data' => "editch45-$id_channel-max_save_banner-1"],['text' => "-1",'callback_data' => "editch45-$id_channel-max_save_banner-2"],['text' => "+1",'callback_data' => "editch45-$id_channel-max_save_banner-3"],['text' => "+5",'callback_data' => "editch45-$id_channel-max_save_banner-4"]],
            [['text' => "ویرایش بازه های ارسال : {$getchannel['gap_send_next_banner']}" ,'callback_data' => "show"]],
            [['text' => "-5",'callback_data' => "editch45-$id_channel-gap_send_next_banner-1"],['text' => "-1",'callback_data' => "editch45-$id_channel-gap_send_next_banner-2"],['text' => "+1",'callback_data' => "editch45-$id_channel-gap_send_next_banner-3"],['text' => "+5",'callback_data' => "editch45-$id_channel-gap_send_next_banner-4"]],
            [['text' => "برگشت",'callback_data' => "back_home"]], 
        ]])]);
        $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID() ]);
    }else $telegram->answerCallbackQuery(['callback_query_id' => $telegram->Callback_ID(), 'text' => "کانال یافت نشد"]);
}
//======================= [ اضافه کردن دسترسی ]===========================
elseif(isset($data) && $data == 'add_access'){
	$telegram->editMessageText(['chat_id' => $from_id,'text' => "چت آیدی کاربری که میخواهید به او دسترسی دهید را ارسال کنید",'message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'برگشت' ,'callback_data' => "back_home"]],  
    ]])]);
    $DB->update('users',['command' => 'add_access'],"from_id=$from_id");
	exit;
}
elseif(isset($text) && $command == 'add_access'){
	$getuser = $DB->select('users',"from_id=$text",'is_admin');
    if(isset($getuser)){
        if($getuser['is_admin'] == 0){
            $DB->update('users',['is_admin' => 1],"from_id=$text");
            $DB->update('users',['command' => 'none'],"from_id=$from_id");
            $telegram->sendMessage(['chat_id' => $from_id,'text' => 'دسترسی استفاده از ربات به کاربر داده شد','reply_markup' => json_encode(['inline_keyboard'=>[
                [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
                [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
                [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
                [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
                [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],  
                [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]],   
            ]])]);
        }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "کاربر از قبل دسترسی استفاده از ربات را دارد\nلطفا دوباره ارسال کنید",'parse_mode' => 'html']);
    }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "کاربر جز اعضای ربات نیست\nلطفا دوباره ارسال کنید",'parse_mode' => 'html']);
    exit;
}
//======================= [ اضافه کردن دسترسی ]===========================
elseif(isset($data) && $data == 'del_access'){
	$telegram->editMessageText(['chat_id' => $from_id,'text' => 'چت آیدی کاربری که میخواهید دسترسی او را بگیرید را ارسال کنید','parse_mode' => 'html','message_id' => $message_id,'reply_markup' => json_encode(['inline_keyboard'=>[
        [['text' => 'برگشت' ,'callback_data' => "back_home"]],  
    ]])]);
    $DB->update('users',['command' => 'del_access'],"from_id=$from_id");
	exit;
}
elseif(isset($text) && $command == 'del_access'){
	$getuser = $DB->select('users',"from_id=$text",'is_admin');
    if(isset($getuser)){
        if($getuser['is_admin'] == 1){
            $DB->update('users',['is_admin' => 0],"from_id=$text");
            $DB->update('users',['command' => 'none'],"from_id=$from_id");
            $telegram->sendMessage(['chat_id' => $from_id,'text' => 'دسترسی استفاده از ربات از کاربر گرفته شد','reply_markup' => json_encode(['inline_keyboard'=>[
                [['text' => 'اضافه کردن بنر' ,'callback_data' => "add_banner"]],
                [['text' => 'بنر های ثبت شده' ,'callback_data' => "registered_banners-1"]],
                [['text' => 'اضافه کردن کانال' ,'callback_data' => "add_channel"]],
                [['text' => 'کانال های ثبت شده' ,'callback_data' => "registered_channels-1"]],
                [['text' => 'اضافه کردن دسترسی' ,'callback_data' => "add_access"]],  
                [['text' => 'حذف کردن دسترسی' ,'callback_data' => "del_access"]],   
            ]])]);
        }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "کاربر دسترسی استفاده از ربات را ندارد.\nلطفا یک مورد دیگر را ارسال کنید.",'parse_mode' => 'html']);
    }else $telegram->sendMessage(['chat_id' => $from_id,'text' => "کاربر جز اعضای ربات نیست\nلطفا دوباره ارسال کنید",'parse_mode' => 'html']);
    exit;
}
?>