<?php
function bot($method, $datas = []){
	global $API_KEY;
    $url = "https://api.telegram.org/bot" . $API_KEY . "/" . $method;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
    $res = curl_exec($ch);
    if (curl_error($ch)) {
        var_dump(curl_error($ch));
    } else {
        return json_decode($res);
    }
}
function DBconnect(){
	global $DBNAME;
	global $DBUSERNAME;
	global $DBPASS;
	$connect = mysqli_connect('localhost',$DBUSERNAME,$DBPASS,$DBNAME);
	mysqli_query($connect,"SET NAMES utf8mb4");
	return $connect;
}
function SendMessage($chat_id,$text,$keyboard = null, $id = null){
	bot('sendMessage',[
	'chat_id' => $chat_id,
	'text' => $text,
	'reply_markup' => $keyboard,
	'reply_to_message_id' => $id,
	'parse_mode' => 'html',
	'disable_web_page_preview' => 'true'
	]);
}
function SendFile($chat_id,$type,$file_id,$caption = null,$key = null,$id = null){
	bot("send$type",[
	'chat_id' => $chat_id,
	"$type" => $file_id,
	'caption' => $caption,
	'reply_markup' => $key,
	'parse_mode' => 'html',
	'reply_to_message_id' => $id,
	]);
}
function AnswerCallbackquery($chat_id,$text,$alert = false){
	bot('answercallbackquery',[
	'callback_query_id' => $chat_id,
	'text' => $text,
	'show_alert' => $alert
	]);
}
function answerInlineQuery($inline_query_id,$results){
	bot('answerInlineQuery',[
		'inline_query_id' => $inline_query_id,
		'results' => $results,
	]);
}
function editMessageText($chat_id,$text,$keyboard,$message_id){
	bot('editmessagetext',[
	'chat_id' => $chat_id,
	'text' => $text,
	'reply_markup' => $keyboard,
	'message_id' => $message_id,
	'parse_mode' => 'html'
	]);
}
function editmessagereplymarkup($chatid, $messageid, $key){
	bot('editmessagereplymarkup',[
		'chat_id' => $chatid,
		'message_id' => $messageid,
		'reply_markup' => $key,
	]);
}
function getChatMember($user_id,$chat_id){
	return bot('getChatMember',[
	'chat_id' => $chat_id,
	'user_id' => $user_id
	])->result->status;
}
function DeleteMessage($chat_id,$message_id){
	bot('deletemessage',[
	'chat_id' => $chat_id,
	'message_id' => $message_id
	]);
}
function ForwardMessage($chat_id,$from_chat_id,$message_id){
    return bot('forwardmessage',[
        'chat_id' => $chat_id,
        'from_chat_id' => $from_chat_id,
        'message_id' => $message_id
    ]);
}
function checkJoin($user_id){
	$sql = DBconnect();
	$arr = [];
	$channels = mysqli_query($sql,"SELECT * FROM `channel` ");
	while($fetch = mysqli_fetch_assoc($channels)){
		if(getChatMember($user_id,$fetch['chatid']) == 'left') $arr[] = [['text' => $fetch['title'],'url' => $fetch['invite_link'] ]];
	}
	return $arr;
}

function get_api_status() { 
	$curl = curl_init();
	curl_setopt_array($curl, array(
	    CURLOPT_URL => 'https://api.nowpayments.io/v1/status',
	    CURLOPT_RETURNTRANSFER => true,
	    CURLOPT_ENCODING => '',
	    CURLOPT_MAXREDIRS => 10,
	    CURLOPT_TIMEOUT => 0,
	    CURLOPT_FOLLOWLOCATION => true,
	    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => 'GET',
	));
	$response = curl_exec($curl);
	curl_close($curl);
	return $response;
}
function get_the_minimum_payment_amount($from,$to,$fiat_equivalent,$api_key) {
	$fiat_cond = '&fiat_equivalent='.$fiat_equivalent;
	if($fiat_equivalent == '') $fiat_cond = "";
	$curl = curl_init();
	curl_setopt_array($curl, array(
	    CURLOPT_URL => 'https://api.nowpayments.io/v1/min-amount?currency_from='.$from.'&currency_to='.$to.$fiat_cond,
	    CURLOPT_RETURNTRANSFER => true,
	    CURLOPT_ENCODING => '',
	    CURLOPT_MAXREDIRS => 10,
	    CURLOPT_TIMEOUT => 0,
	    CURLOPT_FOLLOWLOCATION => true,
	    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	    CURLOPT_CUSTOMREQUEST => 'GET',
	    CURLOPT_HTTPHEADER => array(
		    'x-api-key: '.$api_key
	    ),
	));
	$response = curl_exec($curl);
	curl_close($curl);
	return $response;
}
         
function create_payment($price_amount,$price_currency,$pay_currency,$ipn_callback_url,$order_id,$order_description,$api_key) {
	$curl = curl_init();
	curl_setopt_array($curl, array(
	    CURLOPT_URL => 'https://api.nowpayments.io/v1/payment',
	    CURLOPT_RETURNTRANSFER => true,
	    CURLOPT_ENCODING => '',
	    CURLOPT_MAXREDIRS => 10,
	    CURLOPT_TIMEOUT => 0,
	    CURLOPT_FOLLOWLOCATION => true,
	    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	    CURLOPT_CUSTOMREQUEST => 'POST',
	    CURLOPT_POSTFIELDS =>'{
	        "price_amount": "'.$price_amount.'",
	        "price_currency": "'.$price_currency.'",
	        "pay_currency": "'.$pay_currency.'",
			"ipn_callback_url": "'.$ipn_callback_url.'",
	        "order_id": "'.$order_id.'",
	        "order_description": "'.$order_description.'"
	    }',
	    CURLOPT_HTTPHEADER => array(
		    'x-api-key: '.$api_key,
		    'Content-Type: application/json'
	    ),
	));
	$response = curl_exec($curl);
	curl_close($curl);
	return $response;
}
function get_payment_status($payment_id,$api_key) {
	$curl = curl_init();
	curl_setopt_array($curl, array(
	    CURLOPT_URL => 'https://api.nowpayments.io/v1/payment/'.$payment_id,
	    CURLOPT_RETURNTRANSFER => true,
	    CURLOPT_ENCODING => '',
	    CURLOPT_MAXREDIRS => 10,
	    CURLOPT_TIMEOUT => 0,
	    CURLOPT_FOLLOWLOCATION => true,
	    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	    CURLOPT_CUSTOMREQUEST => 'GET',
	    CURLOPT_HTTPHEADER => array(
	      	'x-api-key: '.$api_key
	    ),
	));
	$response = curl_exec($curl);
	curl_close($curl);
	return $response;
}
function get_available_currencies($api_key) {
	$curl = curl_init();
	curl_setopt_array($curl, array(
	    CURLOPT_URL => 'https://api.nowpayments.io/v1/currencies',
	    CURLOPT_RETURNTRANSFER => true,
	    CURLOPT_ENCODING => '',
	    CURLOPT_MAXREDIRS => 10,
	    CURLOPT_TIMEOUT => 0,
	    CURLOPT_FOLLOWLOCATION => true,
	    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	    CURLOPT_CUSTOMREQUEST => 'GET',
		CURLOPT_POSTFIELDS =>'{
	        "fixed_rate": "'.true.'"
	    }',
	    CURLOPT_HTTPHEADER => array(
	      	'x-api-key: '.$api_key
	    ),
	));
	$response = curl_exec($curl);
	curl_close($curl);
	return $response;
}
function create_JWT_token($email,$password) {
	$curl = curl_init();
	curl_setopt_array($curl, array(
	    CURLOPT_URL => 'https://api.nowpayments.io/v1/auth',
	    CURLOPT_RETURNTRANSFER => true,
	    CURLOPT_ENCODING => '',
	    CURLOPT_MAXREDIRS => 10,
	    CURLOPT_TIMEOUT => 0,
	    CURLOPT_FOLLOWLOCATION => true,
	    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	    CURLOPT_CUSTOMREQUEST => 'POST',
	    CURLOPT_POSTFIELDS => http_build_query(array(
			"email" => $email,
			"password" => $password
		)),
		CURLOPT_HTTPHEADER => array(
			'Content-Type: application/x-www-form-urlencoded',
	    ),
	));
	$response = curl_exec($curl);
	curl_close($curl);
	return $response;
}
function convertFarsiToEnglish($englishNumber = null){
	$newNumbers = range(0, 9);
	$arabic = array('٠', '١', '٢', '٣', '٤', '٥', '٦', '٧', '٨', '٩');
	$persian = array('۰', '۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹');
	$englishNumber =  str_replace($arabic, $newNumbers, $englishNumber);
	$englishNumber =  str_replace($persian, $newNumbers, $englishNumber);
	return $englishNumber ;
}
function online_time_fa($online_time){
	$ttt = time() - $online_time ;
	if ($ttt < 20 * 60 ) {
		return "آنلاین" ;
	}elseif ($ttt >= 20 * 60 && $ttt < 60 * 60) {
		return "کمی قبل آنلاین بود" ;
	}elseif ($ttt >= 60 * 60) {
		return "آفلاین" ;
	}
}
?>